import java.util.Map;
import java.util.HashMap;
import java.io.File;
import java.io.FileOutputStream;
import java.lang.Thread;

import com.google.gson.Gson;
import com.google.gson.JsonObject;

import com.unimas.esql_api.v2.ESql;


public class Test_esql_api_v2 {

    public class FileResult {
        public String _file_id;
    }

    public static void main(String[] args) {

        try {
//            ESql esql = new ESql("10.68.23.81:8001","root","toor");
             ESql esql = new ESql("localhost:8001", "root", "toor");

            String test_file = args[0] + "/websql/tests/data/es_guide_cn.pdf";
            String save_file = "/tmp/es_guide_cn.pdf";
            new File(save_file).delete();

            esql.print_result(esql.login());

            esql.print_result(esql.execute("DROP TABLE file_test;"));
            esql.print_result(esql.execute("CREATE TABLE file_test(my_file FILE {analyzer=ik});"));

            Map file_set = new HashMap();
            file_set.put("_name", "es_guide_cn.xxx");
            file_set.put("_content_type", "application/xxx");
            file_set.put("_language", "en");
            String my_file_value = esql.fileSet(test_file, file_set);
            esql.print_result(esql.execute("INSERT INTO file_test(my_file()) VALUES(" + my_file_value + ");"));
            Thread.sleep(500);  // CREATE（INSERT）成功后，ES 需要时间同步节点
            esql.print_result(esql.execute("FLUSH file_test;"));

            ESql.Result select_result = esql.execute("SELECT * FROM file_test WHERE my_file like '分析';");   // analyser
            esql.print_result(select_result);
            Gson gson = new Gson();
            if (select_result.count > 0) {
                for (int i = 0; i < select_result.count; i++) {
                    JsonObject row = select_result.data.get(i).getAsJsonObject();
                    String file_attr = row.get("my_file").getAsString();

                    FileResult file = gson.fromJson(file_attr, FileResult.class);
                    ESql.Result result = esql.fileGet(file._file_id);

                    FileOutputStream out = new FileOutputStream(save_file);
                    out.write(result.file);
                    out.close();

                    System.out.println("-- " + file._file_id + "   >   " + save_file  + "    length: " + result.file.length);
                    esql.print_result(result);
                }
            }

            esql.print_result(esql.logout());

        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
